baseSprite = { };
baseSprite.dist = 0;
baseSprite.state = 0;
baseSprite.uiID = "ui";
baseSprite.textID = 0;

function baseSprite:new ( )
	local o = { };
	o.textID = action.getActionID ( objSprite, "UI - 3D Label" );
	o.textShow = false;
	action.setActionParam ( objSprite, o.textID, "Enable 3D Label", "false" );

	setmetatable ( o, self );
	self.__index = self;
	return o;
end

--[[Prop|string]] key = "p";
--[[Prop|string]] text = "Press P to PickUp";
--[[Prop|string]] playerTag = "Player";
--[[Prop|float]] distToPlayer = 2;

function baseSprite:params ( )
	self.key = entity.getDynamicProperty ( objSprite, "key" );
	self.text = entity.getDynamicProperty ( objSprite, "text" );
	self.playerTag = entity.getDynamicProperty ( objSprite, "playerTag" );
	self.range = tonumber ( entity.getDynamicProperty ( objSprite, "distToPlayer" ) );
	self.player = entity.getEntityIDFromTag ( self.playerTag );

	action.setActionParam ( objSprite, self.textID, "Caption", self.text );
end

objSprite = 0;
sprite2d = 0;

function onInit ( objID )
	objSprite = objID;
	sprite2d = baseSprite:new ( );
	sprite2d:params ( );
	sky.setVar ( "sKey", sprite2d.key );
	time.startMultiTimer ( 1, objSprite, 1000 );
end

function onKeyDown ( key )
	local sKey = sprite2d.key;
	
	if ( key == sKey or key == string.upper ( sKey ) ) then
		local bCarry = sky.getVar ( "bCarry" );

		if ( bCarry == "0" ) then
			time.stopMultiTimer ( 1, objSprite );
			action.setActionParam ( objSprite, sprite2d.textID, "Enable 3D Label", "false" );
			sky.setVar ( "bCarry", "1" );
			sky.setVar ( "iCarry", tostring ( objSprite ) );
		else
			time.startMultiTimer ( 1, objSprite, 1000 );
			action.setActionParam ( objSprite, sprite2d.textID, "Enable 3D Label", "true" );
			sky.setVar ( "bCarry", "0" );
			sky.setVar ( "iCarry", "0" );
		end
	end
end

function onMultiTimer ( timerID )
	sprite2d.dist = entity.getDistance ( objSprite, sprite2d.player )

	if ( sprite2d.dist > sprite2d.range ) then
		action.setActionParam ( objSprite, sprite2d.textID, "Enable 3D Label", "false" );
	else
		action.setActionParam ( objSprite, sprite2d.textID, "Enable 3D Label", "true" );
	end
end